/*
 * main.h
 *
 *  Created on: 06.06.2011
 *      Author: gen4ik
 */

#ifndef MAIN_H_
#define MAIN_H_

#include <stdio.h>
#include <stdlib.h>
#include <avr32/io.h>
#include <avr32/io.h>
#include <avr32/io.h>

#include "compiler.h"
#include "intc.h"
#include "gpio.h"
#include "spi.h"
#include "pm.h"
#include "flashc.h"
#include "tc.h"
#include "twi.h"
#include "eic.h"
#include "pwm.h"

#include "delay.h"
//****************************************************************************************
#define AVR32_SPI0_MISO_0_PIN              11
#define AVR32_SPI0_MISO_0_FUNCTION         0
#define AVR32_SPI0_MOSI_0_PIN              12
#define AVR32_SPI0_MOSI_0_FUNCTION         0
#define AVR32_SPI0_NPCS_0_PIN              10
#define AVR32_SPI0_NPCS_0_FUNCTION         0
#define AVR32_SPI0_NPCS_1_PIN              8
#define AVR32_SPI0_NPCS_1_FUNCTION         1
#define AVR32_SPI0_NPCS_2_PIN              9
#define AVR32_SPI0_NPCS_2_FUNCTION         1
#define AVR32_SPI0_SCK_0_PIN               13
#define AVR32_SPI0_SCK_0_FUNCTION          0

#define LCD_RESET_GPIO   	AVR32_PIN_PA14
#define LCD_RS_GPIO   		AVR32_PIN_PA09


//****************************************************************************************
#define LED0_GPIO   AVR32_PIN_PB19
#define LED1_GPIO   AVR32_PIN_PB20
#define LED2_GPIO   AVR32_PIN_PB21
#define LED3_GPIO   AVR32_PIN_PB22

#define led1_off() gpio_clr_gpio_pin(LED0_GPIO)
#define led1_on() gpio_set_gpio_pin(LED0_GPIO)
#define led2_off() gpio_clr_gpio_pin(LED1_GPIO)
#define led2_on() gpio_set_gpio_pin(LED1_GPIO)
#define led3_off() gpio_clr_gpio_pin(LED2_GPIO)
#define led3_on() gpio_set_gpio_pin(LED2_GPIO)
#define led4_off() gpio_clr_gpio_pin(LED3_GPIO)
#define led4_on() gpio_set_gpio_pin(LED3_GPIO)

//****************************************************************************************
#define FOSC0           12000000
#define OSC0_STARTUP    AVR32_PM_OSCCTRL0_STARTUP_2048_RCOSC  //!< Osc0 startup time: RCOsc periods.

#  define EXAMPLE_GCLK_ID             2
#  define EXAMPLE_GCLK_PIN            AVR32_PM_GCLK_2_1_PIN
#  define EXAMPLE_GCLK_FUNCTION       AVR32_PM_GCLK_2_1_FUNCTION

//****************************************************************************************

#define KAMERA_RESET 		AVR32_PIN_PA28
#define KAMERA_CLOCK_IN		AVR32_PIN_PB30
#define KAMERA_DCLOCK		AVR32_PIN_PA21
#define KAMERA_HDCLOCK		AVR32_PIN_PA22
#define KAMERA_VDCLOCK		AVR32_PIN_PA23

#define KAMERA_DATA0		AVR32_PIN_PB00
#define KAMERA_DATA1		AVR32_PIN_PB01
#define KAMERA_DATA2		AVR32_PIN_PB02
#define KAMERA_DATA3		AVR32_PIN_PB03
#define KAMERA_DATA4		AVR32_PIN_PB04
#define KAMERA_DATA5		AVR32_PIN_PB05
#define KAMERA_DATA6		AVR32_PIN_PB06
#define KAMERA_DATA7		AVR32_PIN_PB07

#define TWI_SPEED 			400000       // Speed of TWI
#define TWI_CAM_ADDRESS		0x3C
#define TWI_SDA				AVR32_PIN_PA29
#define TWI_SCL				AVR32_PIN_PA30


//****************************************************************************************
//PWM
#define EXAMPLE_PWM_PIN             AVR32_PWM_0_PIN
#define EXAMPLE_PWM_FUNCTION        AVR32_PWM_0_FUNCTION
#define EXAMPLE_PWM_CHANNEL_ID      0

//IRQ
//#define EXT_INT_EXAMPLE_PIN_LINE1               AVR32_EIC_EXTINT_1_PIN
//#define EXT_INT_EXAMPLE_FUNCTION_LINE1          AVR32_EIC_EXTINT_1_FUNCTION
//#define EXT_INT_EXAMPLE_LINE1                   EXT_INT0
//#define EXT_INT_EXAMPLE_IRQ_LINE1               AVR32_EIC_IRQ_0


extern unsigned char daten[24578];

//extern unsigned char daten[1561];;
//*************************************************************************************
void led_install(void);
char io_start_spi(void);

char io_start_twi(void);
void io_start_clock(void);
void led_error_on(void);

//i2c
char i2c_recive(unsigned char device_adresse,unsigned char device_reg,unsigned char* data);
char i2c_send(unsigned char device_adresse,unsigned char device_reg,unsigned char data);
void i2c_init(void);
//PWM
void pwm_init_g(void);
void pwm_set_feq(unsigned int dyti ,unsigned int periode);
//IRQ
void init_irq_hd(void);
void init_irq_g(void);
void init_irq_nmi(void);
unsigned int get_zahl(void);

#endif /* MAIN_H_ */
