/*
 * i2c.c
 *
 *  Created on: 10.06.2011
 *      Author: gen4ik
 */

#include "main.h"

void i2c_init(void)
{
	gpio_set_gpio_open_drain_pin(TWI_SDA);
	gpio_set_gpio_open_drain_pin(TWI_SCL);
}

char i2c_recive(unsigned char device_adresse,unsigned char device_reg,unsigned char* data)
{
	unsigned char i=0,dd=0x40;
	unsigned char ant=0;
	gpio_clr_gpio_pin(TWI_SDA);
	gpio_clr_gpio_pin(TWI_SCL);
	udelay(100);

	//Send addresse
	dd=0x40;
	for (i=0;i<7;i++)
	{
		if(dd & device_adresse)
			gpio_set_gpio_pin(TWI_SDA);
		else
			gpio_clr_gpio_pin(TWI_SDA);
		gpio_set_gpio_pin(TWI_SCL);
		udelay(100);
		gpio_clr_gpio_pin(TWI_SCL);
		udelay(100);
		dd=(dd>>1);
	}
	//Bit Read/Write Read=>1 Write=>0
	//udelay(1000);
	gpio_clr_gpio_pin(TWI_SDA);
	gpio_set_gpio_pin(TWI_SCL);
	udelay(100);
	gpio_clr_gpio_pin(TWI_SCL);
	udelay(100);

	//ACK ->
	//Acknowledge: SDA line is low while the SCL line is high at the 9 th clock cycle
	//gpio_clr_gpio_pin(TWI_SDA);
	//gpio_set_gpio_pin(TWI_SCL);
	gpio_set_gpio_open_drain_pin(TWI_SDA);
	gpio_set_gpio_pin(TWI_SCL);
	udelay(100);
	if(gpio_get_pin_value(TWI_SDA)==1)
		return -1;
	//udelay(50);
	gpio_clr_gpio_pin(TWI_SCL);
	udelay(100);
	gpio_clr_gpio_pin(TWI_SDA);

	//send Daten
	dd=0x80;
	for (i=0;i<8;i++)
	{
		if(dd & device_reg)
			gpio_set_gpio_pin(TWI_SDA);
		else
			gpio_clr_gpio_pin(TWI_SDA);
		gpio_set_gpio_pin(TWI_SCL);
		udelay(100);
		gpio_clr_gpio_pin(TWI_SCL);
		udelay(100);
		dd=(dd>>1);
	}
	//udelay(1000);
	//ACK ->i2c_send
	//Acknowledge: SDA line is low while the SCL line is high at the 9 th clock cycle
	gpio_set_gpio_open_drain_pin(TWI_SDA);
	gpio_set_gpio_pin(TWI_SCL);
	udelay(100);
	if(gpio_get_pin_value(TWI_SDA)==1)
		return -2;
	//udelay(50);
	gpio_clr_gpio_pin(TWI_SCL);
	udelay(100);
	//gpio_clr_gpio_pin(TWI_SDA);



	//**************************************************************************************
	gpio_set_gpio_open_drain_pin(TWI_SCL);
	gpio_set_gpio_open_drain_pin(TWI_SDA);
	udelay(10);
	gpio_clr_gpio_pin(TWI_SDA);
	gpio_clr_gpio_pin(TWI_SCL);
	udelay(100);

	dd=0x40;
	for (i=0;i<7;i++)
	{
		if(dd & device_adresse)
			gpio_set_gpio_pin(TWI_SDA);
		else
			gpio_clr_gpio_pin(TWI_SDA);
		gpio_set_gpio_pin(TWI_SCL);
		udelay(100);
		gpio_clr_gpio_pin(TWI_SCL);
		udelay(100);
		dd=(dd>>1);
	}
	//Bit Read/Write Read=>1 Write=>0
	//udelay(1000);
	gpio_set_gpio_pin(TWI_SDA);
	gpio_set_gpio_pin(TWI_SCL);
	udelay(100);
	gpio_clr_gpio_pin(TWI_SCL);
	gpio_set_gpio_open_drain_pin(TWI_SDA);
	udelay(100);


	//**************************************************************************************
	//Daten empfangen
	dd=0x80;
	for (i=0;i<8;i++)
	{

		gpio_set_gpio_pin(TWI_SCL);
		udelay(100);
		ant=ant |gpio_get_pin_value(TWI_SDA);
		gpio_clr_gpio_pin(TWI_SCL);
		udelay(100);
		if(i!=7)
			ant=(ant<<1);
	}

	//udelay(100);
	//ACK ->
	//Acknowledge: SDA line is low while the SCL line is high at the 9 th clock cycle
	//gpio_clr_gpio_pin(TWI_SDA);
	gpio_set_gpio_open_drain_pin(TWI_SDA);
	gpio_set_gpio_pin(TWI_SCL);
	udelay(100);
	gpio_clr_gpio_pin(TWI_SCL);
	udelay(100);
	//gpio_clr_gpio_pin(TWI_SDA);


	//Ende
	gpio_set_gpio_open_drain_pin(TWI_SCL);
	udelay(10);
	gpio_set_gpio_open_drain_pin(TWI_SDA);

	//gpio_set_gpio_pin(TWI_SCL);
	//udelay(100);
	*data=ant;
	udelay(100);
	return 0;
}


char i2c_send(unsigned char device_adresse,unsigned char device_reg,unsigned char data)
{
	unsigned char i=0,dd=0x40;

	gpio_clr_gpio_pin(TWI_SDA);
	gpio_clr_gpio_pin(TWI_SCL);
	udelay(100);

	//Send addresse
	dd=0x40;
	for (i=0;i<7;i++)
	{
		if(dd & device_adresse)
			gpio_set_gpio_pin(TWI_SDA);
		else
			gpio_clr_gpio_pin(TWI_SDA);
		gpio_set_gpio_pin(TWI_SCL);
		udelay(100);
		gpio_clr_gpio_pin(TWI_SCL);
		udelay(100);
		dd=(dd>>1);
	}
	//Bit Read/Write Read=>1 Write=>0
	//udelay(1000);
	gpio_clr_gpio_pin(TWI_SDA);
	gpio_set_gpio_pin(TWI_SCL);
	udelay(100);
	gpio_clr_gpio_pin(TWI_SCL);
	udelay(100);

	//ACK ->
	//Acknowledge: SDA line is low while the SCL line is high at the 9 th clock cycle
	//gpio_clr_gpio_pin(TWI_SDA);
	//gpio_set_gpio_pin(TWI_SCL);
	gpio_set_gpio_open_drain_pin(TWI_SDA);
	gpio_set_gpio_pin(TWI_SCL);
	udelay(100);
	if(gpio_get_pin_value(TWI_SDA)==1)
		return -1;
	//udelay(50);
	gpio_clr_gpio_pin(TWI_SCL);
	udelay(100);
	gpio_clr_gpio_pin(TWI_SDA);

	//send Daten
	dd=0x80;
	for (i=0;i<8;i++)
	{
		if(dd & device_reg)
			gpio_set_gpio_pin(TWI_SDA);
		else
			gpio_clr_gpio_pin(TWI_SDA);
		gpio_set_gpio_pin(TWI_SCL);
		udelay(100);
		gpio_clr_gpio_pin(TWI_SCL);
		udelay(100);
		dd=(dd>>1);
	}
	//udelay(1000);
	//ACK ->i2c_send
	//Acknowledge: SDA line is low while the SCL line is high at the 9 th clock cycle
	gpio_set_gpio_open_drain_pin(TWI_SDA);
	gpio_set_gpio_pin(TWI_SCL);
	udelay(100);
	if(gpio_get_pin_value(TWI_SDA)==1)
		return -1;
	//udelay(50);
	gpio_clr_gpio_pin(TWI_SCL);
	udelay(100);
	gpio_clr_gpio_pin(TWI_SDA);


	//Daten senden
	dd=0x80;
	for (i=0;i<8;i++)
	{
		if(dd & data)
			gpio_set_gpio_pin(TWI_SDA);
		else
			gpio_clr_gpio_pin(TWI_SDA);
		gpio_set_gpio_pin(TWI_SCL);
		udelay(100);
		gpio_clr_gpio_pin(TWI_SCL);
		udelay(100);
		dd=(dd>>1);
	}

	//udelay(100);
	//ACK ->
	//Acknowledge: SDA line is low while the SCL line is high at the 9 th clock cycle
	gpio_set_gpio_open_drain_pin(TWI_SDA);
	gpio_set_gpio_pin(TWI_SCL);
	udelay(100);
	if(gpio_get_pin_value(TWI_SDA)==1)
		return -1;
	//udelay(50);
	gpio_clr_gpio_pin(TWI_SCL);
	udelay(100);
	gpio_clr_gpio_pin(TWI_SDA);


	//Ende
	gpio_set_gpio_open_drain_pin(TWI_SDA);
	gpio_set_gpio_open_drain_pin(TWI_SCL);
	//gpio_set_gpio_pin(TWI_SCL);
	udelay(100);
	return 0;
}
