/*
 * pwm_g.c
 *
 *  Created on: 10.06.2011
 *      Author: gen4ik
 */
#include "main.h"

void pwm_set_feq(unsigned int dyti ,unsigned int periode)
{
	avr32_pwm_channel_t pwm_channel = { .ccnt = 0 };  // One channel config.
	unsigned int channel_id;
	pwm_opt_t  pwm_opt;
	channel_id = EXAMPLE_PWM_CHANNEL_ID;

	pwm_stop_channels(1 << channel_id);
	// PWM controller configuration.
		  pwm_opt.diva = AVR32_PWM_DIVA_CLK_OFF;
		  pwm_opt.divb = AVR32_PWM_DIVB_CLK_OFF;
		  pwm_opt.prea = AVR32_PWM_PREA_MCK;
		  pwm_opt.preb = AVR32_PWM_PREB_MCK;

		  pwm_init(&pwm_opt);

		  pwm_channel.CMR.calg = PWM_MODE_LEFT_ALIGNED;       // Channel mode.
		  pwm_channel.CMR.cpol = PWM_POLARITY_LOW;            // Channel polarity.
		  pwm_channel.CMR.cpd = PWM_UPDATE_DUTY;              // Not used the first time.
		  pwm_channel.CMR.cpre = AVR32_PWM_CPRE_MCK_DIV_2;//AVR32_PWM_CPRE_MCK_DIV_2;//AVR32_PWM_CPRE_MCK_DIV_256;  // Channel prescaler.
		  pwm_channel.cdty = dyti;   // Channel duty cycle, should be < CPRD.
		  pwm_channel.cprd = periode;  // Channel period.
		  pwm_channel.cupd = 0;   // Channel update is not used here.
		  // With these settings, the output waveform period will be :
		  // (115200/256)/20 == 22.5Hz == (MCK/prescaler)/period, with MCK == 115200Hz,
		  // prescaler == 256, period == 20.
		  //Dyti 16,Periode 32

		  //Periode 20 -> tiks 1668
		  //periode 22 -> tiks 1702
		  //periode 24 -> tiks 1770
		  //periode 26,28,30 -> geht nicht
		  //periode 32 -> 1562
		  //periode 34 -> 1470
		  //PWM ->1058823 herz
		  //timer 360 herz
		  pwm_channel_init(channel_id, &pwm_channel); // Set channel configuration to channel 0.

		  pwm_start_channels(1 << channel_id);  // Start channel 0.

}

void pwm_init_g(void)
{
	pwm_opt_t  pwm_opt;                                // PWM option config.
	  avr32_pwm_channel_t pwm_channel = { .ccnt = 0 };  // One channel config.
	  // The channel number and instance is used in several functions.
	  // It's defined as local variable for ease-of-use.
	  unsigned int channel_id;

	  channel_id = EXAMPLE_PWM_CHANNEL_ID;
	  gpio_enable_module_pin(EXAMPLE_PWM_PIN, EXAMPLE_PWM_FUNCTION);

	  // PWM controller configuration.
	  pwm_opt.diva = AVR32_PWM_DIVA_CLK_OFF;
	  pwm_opt.divb = AVR32_PWM_DIVB_CLK_OFF;
	  pwm_opt.prea = AVR32_PWM_PREA_MCK;
	  pwm_opt.preb = AVR32_PWM_PREB_MCK;

	  pwm_init(&pwm_opt);

	  pwm_channel.CMR.calg = PWM_MODE_LEFT_ALIGNED;       // Channel mode.
	  pwm_channel.CMR.cpol = PWM_POLARITY_LOW;            // Channel polarity.
	  pwm_channel.CMR.cpd = PWM_UPDATE_DUTY;              // Not used the first time.
	  pwm_channel.CMR.cpre = AVR32_PWM_CPRE_MCK_DIV_2;//AVR32_PWM_CPRE_MCK_DIV_2;//AVR32_PWM_CPRE_MCK_DIV_256;  // Channel prescaler.
	  pwm_channel.cdty = 1;   // Channel duty cycle, should be < CPRD.
	  pwm_channel.cprd = 2;  // Channel period.
	  pwm_channel.cupd = 0;   // Channel update is not used here.
	  // With these settings, the output waveform period will be :
	  // (115200/256)/20 == 22.5Hz == (MCK/prescaler)/period, with MCK == 115200Hz,
	  // prescaler == 256, period == 20.
	  //Dyti 16,Periode 32

	  //Periode 20 -> tiks 1668
	  //periode 22 -> tiks 1702
	  //periode 24 -> tiks 1770
	  //periode 26,28,30 -> geht nicht
	  //periode 32 -> 1562
	  //periode 34 -> 1470
	  //PWM ->1058823 herz
	  //timer 360 herz
	  pwm_channel_init(channel_id, &pwm_channel); // Set channel configuration to channel 0.

	  pwm_start_channels(1 << channel_id);  // Start channel 0.

}
